<html devsite>
  <head>
    <title>Vendor Test Suite (VTS) &amp; Infrastructure</title>
    <meta name="project_path" value="/_project.yaml" />
    <meta name="book_path" value="/_book.yaml" />
  </head>
  <body>
  {% include "_versions.html" %}
  <!--
      Copyright 2017 The Android Open Source Project

      Licensed under the Apache License, Version 2.0 (the "License");
      you may not use this file except in compliance with the License.
      You may obtain a copy of the License at

          http://www.apache.org/licenses/LICENSE-2.0

      Unless required by applicable law or agreed to in writing, software
      distributed under the License is distributed on an "AS IS" BASIS,
      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
      See the License for the specific language governing permissions and
      limitations under the License.
  -->


<p>
  The Android Vendor Test Suite (VTS) provides extensive new functionality for
  Android testing and promotes a test-driven development process. To help the
  Android development community interact with test data, Android includes the
  following testing resources:
</p>

<ul>
  <li><a href="/compatibility/vts/codelab-video">Codelab and Video Tutorials</a>.
  Describes the videos and codelabs on running and developing VTS and CTS-on-GSI on Android {{
  androidPVersionNumber }} and Android 8.1.</li>
  <li><a href="/compatibility/vts/systems">Systems Testing with VTS</a>.
  Describes how to use VTS to test an Android native system implementation, set
  up a testing environment, then test a patch using a VTS plan.</li>
  <li><strong>Test Framework</strong>. Provides details on using the VTS test
  framework. Includes:
  <ul>
    <li><a href="/compatibility/vts/shell-commands">Device shell commands</a>.
    Instructions on how to use device shell commands to execute target-side test
    binaries, to get/set properties, environment variables, and system
    information, and to start/stop the Android framework.</li>
    <li><a href="/compatibility/vts/test-templates">Test templates</a>.
    Details on configuring and using test templates for test modules that are
    not host-side Python subclass of VTS runner's BaseTest.</li>
    <li><a href="/compatibility/vts/sna-hal-testing">Service name aware HAL
    testing</a>. Details on Android {{ androidPVersionNumber }}​ support for
    obtaining the service name of a given HAL instance based on the device on
    VTS is running.</li>
    <li><a href="/compatibility/vts/hal-testability">HAL testability check</a>.
    Details on Android {{ androidPVersionNumber }}​ support for a runtime method
    that uses the device configuration to identify which VTS tests should be
    skipped for that device target.</li>
    <li><a href="/compatibility/vts/multi-device-testing">Multi-device
    testing</a>. Instructions for configuring tests that require interaction
    between multiple Android devices.</li>
  </ul>
  </li>
  <li><strong>VTS Dashboard</strong>. Web-based user interface for viewing VTS
  results. Includes details on:
  <ul>
    <li><a href="setup.html">Setup</a>. Instructions for setting up and
    configuring the VTS Dashboard.</li>
    <li><a href="/compatibility/vts/database.html">Database</a>. A scalable
    back-end to support the continuous integration dashboard.</li>
    <li><a href="/compatibility/vts/ui.html">User Interface</a>. A cohesive user
    interface that uses material design to effectively display information about
    test results, profiling, and coverage.</li>
  </ul>
  </li>
  <li><strong>Lab infrastructure</strong>. Describes the architecture of an
  <a href="/compatibility/vts/automated-test-infra">automated testing
  infrastructure</a> for running VTS, CTS, or other tests on partner devices
  running the AOSP <a href="/setup/build/gsi">Generic System Image (GSI)</a>.
  Requires a <a href="/compatibility/vts/host-controller">Host Controller</a>.
  </li>
  <li><a href="/compatibility/vts/performance.html">binder and hwbinder
  performance tests</a>. Tools for measuring throughput and latency.</li>
</ul>

<p>
  For additional details, refer to the
  <a href="https://codelabs.developers.google.com/codelabs/android-vts/#0" class="external">Android
  VTS Codelab</a> on developer.android.com and the
  <a href="https://www.youtube.com/watch?v=7BX7oSHc7nk&list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva" class="external">Android
  VTS Products video</a> produced by Google Developers.
</p>

  </body>
</html>
